﻿Public Class formWPS
    Public result As Long
    Dim canceled As Long

    Private Sub buttonCancel_Click(sender As Object, e As EventArgs) Handles buttonCancel.Click
        canceled = 1
        Me.Dispose()
    End Sub

    Private Sub buttonOK_Click(sender As Object, e As EventArgs) Handles buttonOK.Click
        Me.Dispose()
    End Sub

    Private Sub formWPS_Shown(sender As Object, e As EventArgs) Handles Me.Shown

        'ATWPS
        'S1:wps started
        'OK
        's0:WIFI DISCONNECTED
        'S2:wps success, connecting ap ...
        's0:WIFI DISCONNECTED
        'S3:WIFI CONNECTED
        's0:WIFI DISCONNECTED
        'S3:WIFI CONNECTED
        'S4:WIFI GOT IP
        'S5:05/20 Fri 06:34:12
        'S6:wps fail
        formMain.SerialPort1.WriteLine("ATWPS")
        Dim txtline As String
        Do
            txtLine = formMain.SerialPort1.ReadLine()
        Loop Until txtLine = ("OK" & vbCr) Or Mid(txtLine, 1, 5) = "ERROR"

        Dim ErrorMessage As String
        Dim timeOut As Long
        Dim startTime As Long
        Dim reqWps As Long = 5
        timeOut = TIMEOUT_WPS
        startTime = Environment.TickCount
        labelMessage.Text = "WPS検索中.."
        ErrorMessage = "WPS接続に失敗しました(Err.1)"
        formMain.SerialPort1.ReadTimeout = 1000
        Do While 1
            txtLine = SerialPort1ReadLineTimeout()
            Select Case Mid(txtLine, 1, 3)
                Case "S2:"
                    'timeOut = TIMEOUT_CONNECT
                    startTime = Environment.TickCount
                    labelMessage.Text = "ネットワーク接続中.."
                    ErrorMessage = "無線ネットワークに接続できませんでした(Err.2)"
                Case "S3:"
                    startTime = Environment.TickCount
                    labelMessage.Text = "IP取得中.."
                    ErrorMessage = "IPアドレスを取得できませんでした(Err.3)"
                Case "S4:"
                    startTime = Environment.TickCount
                    labelMessage.Text = "NTP接続中.."
                    ErrorMessage = "NTPサーバーにアクセスできませんでした(Err.4)"
                Case "S5:"
                    labelMessage.Text = "接続に成功しました！"
                    result = 1
                    Exit Do
                Case "S6:"
                    If reqWps <= 0 Then
                        labelMessage.Text = ErrorMessage
                        Exit Do
                    Else
                        reqWps -= 1
                        formMain.SerialPort1.WriteLine("ATWPS")
                        Do
                            txtline = formMain.SerialPort1.ReadLine()
                        Loop Until txtline = ("OK" & vbCr) Or Mid(txtline, 1, 5) = "ERROR"
                    End If
            End Select
            If Environment.TickCount - startTime >= timeOut Then
                labelMessage.Text = ErrorMessage
                Exit Do
            End If
            Application.DoEvents()
            If canceled = 1 Then
                Exit Sub
            End If
        Loop
        buttonOK.Enabled = 1
        buttonOK.Focus()
        buttonCancel.Enabled = 0
    End Sub
End Class