﻿Module Module1
    Public Const TIMEOUT_COMMAND As Long = 10000
    Public Const TIMEOUT_WAKE As Long = 20000

    Public Const TIMEOUT_WPS As Long = 60000
    Public Const TIMEOUT_BURN As Long = 5000
    Public Const TIMEOUT_CONNECT As Long = 35000

    Public Function SerialPort1ReadLineTimeout() As String
        Try
            SerialPort1ReadLineTimeout = formMain.SerialPort1.ReadLine()
        Catch ex As TimeoutException
            SerialPort1ReadLineTimeout = ""
        End Try
    End Function

    Public Sub SerialPort1Open()
        If formMain.comboComport.Items.Count = 0 Then
            formMain.scanComPort()
            If formMain.comboComport.Items.Count = 0 Then
                Throw New Exception("BitClockが接続されていません")
            End If
        End If

        formMain.SerialPort1.PortName = formMain.comboComport.SelectedItem.ToString
        formMain.SerialPort1.Open()
        Threading.Thread.Sleep(200)
        formMain.SerialPort1.ReadTimeout = TIMEOUT_COMMAND
        formMain.SerialPort1.ReadExisting()
        formMain.SerialPort1.DiscardInBuffer()
    End Sub

    Public Sub SerialPort1OpenConsole()
        SerialPort1Open()
        formMain.SerialPort1.ReadTimeout = 5000

        Dim txtLine As String
        Dim startTime As Long = Environment.TickCount
        formMain.SerialPort1.WriteLine("")
        Do While 1
            Try
                txtLine = formMain.SerialPort1.ReadLine()
                If Mid(txtLine, 1, 5) = "ERROR" Then Exit Do
                If Mid(txtLine, 1, 3) = "S5:" Then Exit Do
                If Mid(txtLine, 1, 3) = "S2:" Then Exit Do
                Threading.Thread.Sleep(100)
            Catch ex As TimeoutException
                formMain.SerialPort1.WriteLine("")
            End Try
            If Environment.TickCount - startTime >= TIMEOUT_WAKE Then Exit Do
        Loop
        formMain.SerialPort1.ReadTimeout = TIMEOUT_COMMAND
    End Sub

    Public Sub SerialPort1Close()
        Try
            formMain.SerialPort1.Close()
        Catch ex As Exception
        End Try
    End Sub

End Module
